(ns twentyquestions.core
  (:gen-class))

(defn number-of-trailing-spaces [string]
  (count (take-while #(= % \space) (reverse string))))

(defn twentyquestions []
  (println "LOADING KNOWLEDGE BASE")
  (dotimes [i 100]
    (print ".")
    (flush)
    (Thread/sleep 100))
  (println ".")
  (println "I'm thinking of something...")
  (println "You have 20 questions to guess what it is.")
  (println "Ask whatever YES OR NO questions you want --")
  (println "I understand English perfectly!")
  (loop [questions 0]
    (if (> questions 20)
      (println "Sorry, you didn't get it. Bye!")
      (do 
        (print "Question" questions "? ")
        (flush)
        (case (number-of-trailing-spaces (read-line))
          0 (println "NO")
          1 (println "YES")
          (do (println "You got it! Good job!") 
              (System/exit 0)))
        (recur (inc questions))))))

(defn -main
  [& args]
  (twentyquestions))
